varying vec4 v_color;
varying vec3 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform sampler2D u_texture2;

uniform vec4 u_color4;

void main() {
	
	vec4 mainTexColor = texture2D(u_texture, v_texCoord.xy);
	vec3 filterTexColor = texture2D(u_texture1, v_texCoord.xy).rgb * u_color4.a;
	vec4 addTexColor = texture2D(u_texture2, v_texCoord.xy) * u_color4.r * 2.0;
	
	float lerpValue = addTexColor.a * v_color.a;
	
	vec3 colorRes = (1.0 - lerpValue) * (mainTexColor.rgb - (filterTexColor * v_color.r));
	colorRes += (addTexColor.rgb * lerpValue);
	
	gl_FragColor.rgb = v_texCoord.z * colorRes;
	gl_FragColor.a = mainTexColor.a;
}