theGameAPI = {}
local COROUTINES_WAITING_TURN_COUNT_DOWN = {}
local mainCoroutine = coroutine.running()

TRUE = 1
FALSE = 0

-- common variables for all scripts

-- defined variables for layout positioning

TOP = -0.5
LEFT = -0.5
MIDDLE = 0.0
BOTTOM = 0.5
RIGHT = 0.5

--global board variables
NUM_TILES_X = 0
NUM_TILES_Y = 0
TILE_PIXEL_SIZE = 0

setAPI = function(slidergameAPI)
	theGameAPI = slidergameAPI;
end

function API_Log(message)
	return  as3.tolua(theGameAPI:LuaCallsToGame("Log", message, "", "", "", "", "", ""))
end

function API_StartTutorial(tutorialType, validInputType)
	return  as3.tolua(theGameAPI:LuaCallsToGame("StartTutorial", tutorialType, validInputType, "", "", "", "", ""))
end

function API_EndTutorial()
	return  as3.tolua(theGameAPI:LuaCallsToGame("EndTutorial", "", "", "", "", "", "", ""))
end

function API_ShowTextBox(textIdToShowLine1)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowTextBox", textIdToShowLine1, "", "", "", "", "", ""))
end

function API_AddInputFilterArea(topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddInputFilterArea", topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY, "", "", ""))
end

function API_ShowFingerAnimation(fromTileX, fromTileY, toTileX, toTileY, timeInMiliseconds)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowFingerAnimation", fromTileX, fromTileY, toTileX, toTileY, timeInMiliseconds, "", ""))
end

function API_ShowArrowAnimation(fromTileX, fromTileY, toTileX, toTileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowArrowAnimation", fromTileX, fromTileY, toTileX, toTileY, "", "", ""))
end

function API_ShowFingerTapAnimation(tileX, tileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowFingerTapAnimation", tileX, tileY, "", "", "", "", ""))
end

function API_ShowFingerBoosterTapAnimation(tileX, tileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowFingerBoosterTapAnimation", tileX, tileY, "", "", "", "", ""))
end

function API_EnableGlobalMasking(enable)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableGlobalMasking", enable, "", "", "", "", "", ""))
end

function API_EnableInputMask(enable, id)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableInputMask", enable, id, "", "", "", "", ""))
end

function API_SetAllowedSliding(slidingType)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetAllowedSliding", slidingType, "", "", "", "", "", ""))
end

--Adds a booster that will only be available during the current level
function API_AddTemporalBooster(booserType, amount)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddTemporalBooster", booserType, amount, "", "", "", "", ""))
end

function API_EnableButton(enable, sceneObjectName)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableButton", enable, sceneObjectName, "", "", "", "", ""))
end

--Possible values for zLayer: "top", "ui", "active_powerup", "board_foreground", "tile_blocker", "item_over_water", "tile_foam", "item_water_line", "item_under_water", "tile_background")
function API_SetGameplayScreenSceneObjectZ(sceneObjectName, zLayer)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetGameplayScreenSceneObjectZ", sceneObjectName, zLayer, "", "", "", "", ""))
end

function API_ShowGameplayScreenSceneObject(sceneObjectName, visible)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowGameplayScreenSceneObject", sceneObjectName, visible, "", "", "", "", ""))
end

function API_EnableMaskTiles(enable, topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableMaskTiles", enable, topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY, "", ""))
end

function API_HighlightItems(tilesList)
	API_Log("Entering in API_HighlightItems")
	return as3.tolua(theGameAPI:LuaCallsToGame("HighlightItems", tilesList, "", "", "", "", "", ""))
end

function API_SetPositionRelativeToObject(objectName, objectNameAnchor, x, y)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetPositionRelativeToObject", objectName, objectNameAnchor, x, y, "", "", ""))
end

function API_SetPositionRelativeToBoardTile(objectName, xTile, yTile, xOffset, yOffset)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetPositionRelativeToBoardTile", objectName, xTile, yTile, xOffset, yOffset, "", ""))
end

function API_EnableHint(enable)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableHint", enable, "", "", "", "", "", ""))
end

function API_AddItemsToSpawnerBuffer(itemsList)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddItemsToSpawnerBuffer", itemsList, "","","","","",""))
end

function API_ClearSpawnerBuffer()
	return  as3.tolua(theGameAPI:LuaCallsToGame("ClearSpawnerBuffer", "","","","","","",""))
end

-- if parent is "" it will be attached to the rootsceneobject.
function API_LoadArbitraryXML(xmlFileToLoad,parentToAttachTo)
	return  as3.tolua(theGameAPI:LuaCallsToGame("LoadArbitrarySceneObject", xmlFileToLoad,parentToAttachTo,"","","","",""))
end

-- call this to clear the things loaded with API_LoadArbitraryXML
function API_RemoveArbitraryXML()
	return  as3.tolua(theGameAPI:LuaCallsToGame("RemoveAllArbitrarySceneObjects", "", "","","","","",""))
end

function API_GetBoardSizeX()
	return  as3.tolua(theGameAPI:LuaCallsToGame("GetBoardSizeX", "", "","","","","",""))
end

function API_GetBoardSizeY()
	return  as3.tolua(theGameAPI:LuaCallsToGame("GetBoardSizeY", "", "","","","","",""))
end

function API_GetTilePixelSize()
	return  as3.tolua(theGameAPI:LuaCallsToGame("GetTilePixelSize", "", "","","","","",""))
end

function API_AddBoardAnimation(tileIndex, slideAxis, amountOfPixels, duration, delay)
	-- slideAxis : horizontal, vertical
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddBoardAnimation", tileIndex, slideAxis, amountOfPixels, duration, delay,"", ""))
end

function API_SlotMachineAnimation(numLinesToMove, numColumnsToMove, totalTime)
	local displacementX = TILE_PIXEL_SIZE * NUM_TILES_X
	local displacementY = TILE_PIXEL_SIZE * NUM_TILES_Y

	local speed = (displacementX + displacementY) / totalTime
	local duration = displacementY / speed
	local dir = 1.0;

	for index = 0, numColumnsToMove-1 do
		local indexInLine = (NUM_TILES_X / 2) - (numColumnsToMove / 2) + index
		API_AddBoardAnimation(indexInLine, 'vertical', displacementY * dir, duration, 0)
		dir = dir * -1.0
	end
	
	local delay = duration
	duration = displacementX / speed
	
	for index = 0, numLinesToMove-1 do
		local indexInColumn = ((NUM_TILES_Y / 2) - (numLinesToMove / 2) + index) * NUM_TILES_X
		API_AddBoardAnimation(indexInColumn, 'horizontal', displacementX * dir, duration, delay)
		dir = dir * -1.0
	end
end


--------------------------------------------------------------------------------------------------------
--LIVING BOARD SPECIFIC FUNCTIONS
function API_SetTileEnabled(tileX, tileY, enabled)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetTileEnabled", tileX, tileY, enabled,"","","",""))
end

function API_PushTileEnabled(refTileX, refTileY, enabled, direction)
	-- direction can be: up, down, right, left
	return  as3.tolua(theGameAPI:LuaCallsToGame("PushTileEnabled", refTileX, refTileY, enabled, direction,"","",""))
end

function API_ShowSetTileEnabledHint(tileX, tileY, numberOfTurnsLeft)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowSetTileEnabledHint", tileX, tileY, numberOfTurnsLeft,"","","",""))
end

function API_ShowPushTileEnabledHint(refTileX, refTileY, enabled, direction, numberOfTurnsLeft)
	-- direction can be: up, down, right, left
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowPushTileEnabledHint", refTileX, refTileY, enabled, direction, numberOfTurnsLeft,"",""))
end

function API_ClearTileEnabledHints()
	return  as3.tolua(theGameAPI:LuaCallsToGame("ClearTileEnabledHints", "", "", "", "", "","",""))
end

function API_SetTileEnabledDelayed(tileX, tileY, enabled, numberOfTurnsToWait)
	API_ShowSetTileEnabledHint(tileX, tileY, numberOfTurnsToWait)
	API_WaitNTurns(numberOfTurnsToWait)
	API_SetTileEnabled(tileX, tileY, enabled)
end

function API_PushTileEnabledDelayed(refTileX, refTileY, enabled, direction, numberOfTurnsToWait)
	-- direction can be: up, down, right, left
	API_ShowPushTileEnabledHint(refTileX, refTileY, enabled, direction, numberOfTurnsToWait)
	API_WaitNTurns(numberOfTurnsToWait)
	API_PushTileEnabled(refTileX, refTileY, enabled, direction)
end

--------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------
-- THREAD MANAGEMENT

function API_StartThread(funct)
	co = coroutine.create(funct)
	coroutine.resume(co)
end
-- pause current thread and wait n turns to wake it up
function API_WaitNTurns(numberOfTurnsToWait)
	local co = coroutine.running() -- get current thread
	if co == nil or co == mainCoroutine then
		API_Log("*******************************************************************************************")
		API_Log("*******************************************************************************************")
		API_Log("INVALID THREAD, CALL API_StartThread TO START A NEW THREAD TO BE ABLE TO USE API_WaitNTurns")
		API_Log("*******************************************************************************************")
		API_Log("*******************************************************************************************")
		return
	end
	COROUTINES_WAITING_TURN_COUNT_DOWN[co] = numberOfTurnsToWait
	return coroutine.yield() -- pause the thread
end

-- count down the turns (this function must be called each OnEndTurn by C++/AS code)
-- and wake up the threads whrn the count down is done
function INTERNAL_WakeUpWaitingThreadsByTurnCountDown()

	local threadsToWake = {}
	for co, turnsCountDown in pairs(COROUTINES_WAITING_TURN_COUNT_DOWN) do
		turnsCountDown = turnsCountDown - 1
		if turnsCountDown <= 0 then
			table.insert(threadsToWake, co)
			COROUTINES_WAITING_TURN_COUNT_DOWN[co] = nil
		else 
			COROUTINES_WAITING_TURN_COUNT_DOWN[co] = turnsCountDown
		end
	end

	for _, co in ipairs(threadsToWake) do
		coroutine.resume(co)
	end
end
--------------------------------------------------------------------------------------------------------

function INTERNAL_InitBoardGlobals()
	NUM_TILES_X = API_GetBoardSizeX()
	NUM_TILES_Y = API_GetBoardSizeY()
	TILE_PIXEL_SIZE = API_GetTilePixelSize()
end

-------------------------------- UTILS -----------------------------------
function equals(o1, o2, ignore_mt)
    if o1 == o2 then return true end
    local o1Type = type(o1)
    local o2Type = type(o2)
    if o1Type ~= o2Type then return false end
    if o1Type ~= 'table' then return false end

    if not ignore_mt then
        local mt1 = getmetatable(o1)
        if mt1 and mt1.__eq then
            --compare using built in method
            return o1 == o2
        end
    end

    local keySet = {}

    for key1, value1 in pairs(o1) do
        local value2 = o2[key1]
        if value2 == nil or equals(value1, value2, ignore_mt) == false then
            return false
        end
        keySet[key1] = true
    end

    for key2, _ in pairs(o2) do
        if not keySet[key2] then return false end
    end
    return true
end

function table.val_to_str ( v )
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
  else
    return "table" == type( v ) and table.tostring( v ) or
      tostring( v )
  end
end

function table.key_to_str ( k )
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. table.val_to_str( k ) .. "]"
  end
end

function table.tostring( tbl )
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, table.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        table.key_to_str( k ) .. "=" .. table.val_to_str( v ) )
    end
  end
  return "{" .. table.concat( result, "," ) .. "}"
end